﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/Object.h"
#include "GOAPAction.generated.h"

/**
 * 
 */
UCLASS()
class COMP250_1_2101327_AI_API UGOAPAction : public UObject
{
	GENERATED_BODY()

public:
	float ActionCost = 1.0f;

	UFUNCTION()
	bool CheckPreConditions(TMap<FString, int> WorldState);
	UFUNCTION()
	TMap<FString, int> ApplyEffects(TMap<FString, int> WorldState);
	
	UPROPERTY()
	TMap<FString, int> PreConditions;
	UPROPERTY()
	TMap<FString, int> Effects;

	UFUNCTION()
	virtual void Init(){}
};
